////////////////////////////////////////////////////////////
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
//               Aliases & Pseudo-Functions               //
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
////////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^ Switches ^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

//----------------- Double Value 89/92+ ------------------//

#ifdef SWITCH_TI89
#define Is89(a,b) (a)
#else
#define Is89(a,b) (b)
#endif

//----------------- Double Value HW1/HW2 -----------------//

#define IsHW2(a,b) ((HW_VERSION != 1) ? a : b)



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^ Pseudo - Functions ^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

//---------------------- Collision -----------------------//

#define Collide(r1,x1,y1,r2,x2,y2) (((x1) < ((x2) + (r2))) \
								 && ((y1) < ((y2) + (r2))) \
								 && (((x1) + (r1)) > (x2)) \
								 && (((y1) + (r1)) > (y2)))

//------------------------ Memory ------------------------//

#define Alloc(p,z) ((p) = malloc(z))
#define Free(p) if (p) { free(p); (p) = NULL; }

//------------------------ Maths -------------------------//

#define Even(i) (((i) + 1) & 0xFFFE)
